<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

// comuser_uploader плагин для MaxSite CMS
// Настройки


$default = array(
		'allowed_types_comuser' => 'gif|jpg|jpeg|png|pdf',
		'frame_types_comuser' => 'pdf',
		'user_subdir' => 'userfile',
		'frame' => '1',		
		
		'no_public_uploads' => '0',
		'show_size' => '1',
		'resize_images' => '1024',
		'resize_images_type' => 'width',
		
		'size_image_mini_w' => '200',		
		'size_image_mini_h' => '150',	
		'resize_mini_type' => 'width',
		'use_watermark' => '0',
		
		'use_watermark_mini' => '0',		
		'upload_max_file_size' => '20000000',		
		'google_pdf_style' => 'width: 600px; height: 200px;',	
        'user_deldir' => 'deleted',		
		'max_count' => '10',

		
);

// mso_add_option('comuser_uploader', $default, 'plugins');

	mso_admin_plugin_options('comuser_uploader', 'plugins', 
		array(
			'allowed_types_comuser' => array(
						'type' => 'text', 
						'name' => t('Разрешенные типы файлов', 'plugins'), 
						'description' => t('Список типов файлов, которые может загружать комюзер (типы указывать через |)<br>Изображениями считаются файлы gif|jpg|jpeg|png, остальные разрешенные типы считаются просто файлами.', 'plugins'),
						'default' => $default['allowed_types_comuser']
			),

			'frame_types_comuser' => array(
						'type' => 'text', 
						'name' => t('Типы файлов - документов', 'plugins'), 
						'description' => t('Разрешенные типы не-изображения (gif|jpg|jpeg|png), для которых будет создаваться bb-код [mydoc]<br>Для остальных не-изображений будет создаваться bb-код [myfile]', 'plugins'),
						'default' => $default['frame_types_comuser']
			),
			
			'user_subdir' => array(
						'type' => 'text', 
						'name' => t('Subdir', 'plugins'), 
						'description' => t('Подкаталог в каталоге uploads для загрузки комюзерами.', 'plugins'),
						'default' => $default['user_subdir']
			),	

			'frame' => array(
						'type' => 'select',
						'name' => t('Создавать фрейм?', 'plugins'),
						'description' => t('Для bb-кода [mydoc] будет создаваться фрейм google-doc', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => $default['frame']
			),
			
			'no_public_uploads' => array(
						'type' => 'select',
						'name' => t('Запретить доступ к загрузкам комьюзера чужим комюзерам', 'plugins'),
						'description' => t('Невозможно будет получить аякс-запросом картинки пользователя другому пользовтелю', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => $default['no_public_uploads']
			),
/* 
			'add_cod_img' => array( // может пригодится
						'type' => 'select',
						'name' => t('Вставлять изображение', 'plugins'),
						'description' => t('Будет вставлятся полное изображение, миниатюра или bb-код', 'plugins'),
						'values' => t('0||bb-код 1||Миниатюра #2||Полное', 'plugins'),
						'default' => '0'
			),
			
			'add_cod_file' => array( // может пригодится
						'type' => 'select',
						'name' => t('Вставлять файл', 'plugins'),
						'description' => t('Будет ссылка или bb-код', 'plugins'),
						'values' => t('0||bb-код #1||Ссылка', 'plugins'),
						'default' => '0'
			),
*/			
			'show_size' => array(
						'type' => 'select',
						'name' => t('Показывать размер', 'plugins'),
						'description' => t('Показывать размер файлов возле имени?', 'plugins'),
						'values' => t('1||Да #2||Нет', 'plugins'),
						'default' => $default['show_size']					
			),
			
			'resize_images' => array(
						'type' => 'text', 
						'name' => t('Ресайз для комюзеров', 'plugins'),
						'description' => t('Укажите размер изображения до которого будет ограничиваться при загрузке комюзером.', 'plugins'),
						'default' => $default['resize_images']			
			),	

			'resize_images_type' => array(
						'type' => 'select', 
						'name' => t('Ресайз для комюзеров - тип', 'plugins'),
						'description' => t('resize_images_type', 'plugins'),
						'values' => t('width||width #height||height #max||max #crop_center_ratio_auto||crop_center_ratio_auto #crop_center_ratio_4_3||crop_center_ratio_4_3 #crop_center_ratio_3_2||crop_center_ratio_3_2 #crop_center_ratio_16_9||crop_center_ratio_16_9', 'plugins'),
						'default' => $default['resize_images_type']				
			),

			'size_image_mini_w' => array(
						'type' => 'text', 
						'name' => t('Ресайз для комюзеров', 'plugins'),
						'description' => t('size_image_mini_w', 'plugins'),
						'default' => $default['size_image_mini_w']			
			),
			
			'size_image_mini_h' => array(
						'type' => 'text', 
						'name' => t('Ресайз для комюзеров', 'plugins'),
						'description' => t('size_image_mini_h', 'plugins'),
						'default' => $default['size_image_mini_h']				
			),			

			'resize_mini_type' => array(
						'type' => 'select', 
						'name' => t('Ресайз mini для комюзеров', 'plugins'),
						'description' => t('resize_mini_type', 'plugins'),
						'values' => t('none||none #width||width #height||height #max||max #crop_center_ratio_auto||crop_center_ratio_auto #crop_center_ratio_4_3||crop_center_ratio_4_3 #crop_center_ratio_3_2||crop_center_ratio_3_2 #crop_center_ratio_16_9||crop_center_ratio_16_9', 'plugins'),
						'default' => $default['resize_mini_type']				
			),
			
			'use_watermark' => array(
						'type' => 'select',
						'name' => t('Watermark', 'plugins'),
						'description' => t('Ставить watermark?', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => $default['use_watermark']				
			),	
			
			'use_watermark_mini' => array(
						'type' => 'select',
						'name' => t('Watermark mini', 'plugins'),
						'description' => t('Ставить watermark у миниатюры?', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => $default['frame_types_comuser']					
			),	
			
			'upload_max_file_size' => array(
						'type' => 'text',
						'name' => t('Максимальный размер файла', 'plugins'),
						'description' => t('upload_max_file_size', 'plugins'),
						'default' => $default['upload_max_file_size']					
			),	

			'google_pdf_style' => array(
						'type' => 'text',
						'name' => t('Дополнительные стили фрейма google для документов pdf', 'plugins'),
						'description' => t('width: 600px; height: 600px;', 'plugins'),
						'default' => $default['google_pdf_style']				
			),	

			'user_deldir' => array(
						'type' => 'text', 
						'name' => t('Deleted dir', 'plugins'), 
						'description' => t('Подкаталог в каталоге uploads для удаленных комюзерами файлов.', 'plugins'),
						'default' => $default['user_deldir']
			),	

			'max_count' => array(
						'type' => 'text', 
						'name' => t('Количество непроверенных загрузок.', 'plugins'), 
						'description' => t('Чтобы не заспамили вносится ограничение на загрузку файлов без проверки.', 'plugins'),
						'default' => $default['max_count']
			),
	
		),
		t('Загрузки комюзеров - настройки', 'plugins'), // титул
		t('Основные настройки загрузок', 'plugins')   // инфо
	);
?>
