<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

// тут загружаются файлы пользователями


// Все проверки.
if ( !($comuser = is_login_comuser()) ) die('no login');

if (isset($_SERVER['HTTP_X_REQUESTED_FILENAME']))
	$fn = $_SERVER['HTTP_X_REQUESTED_FILENAME'];
else 
	die('no file');

if (isset($_SERVER['HTTP_X_REQUESTED_FILEUPDIR']))
	$comusers_id = $_SERVER['HTTP_X_REQUESTED_FILEUPDIR'];
else 
	die('no updir');

if (!is_numeric($comusers_id) or ($comuser['comusers_id'] != $comusers_id)) die('wrong comusers');

mso_checkreferer();

$ext = strtolower(substr(strrchr($fn, '.'), 1));

$options = mso_get_option('comuser_uploader', 'plugins', array() );

$allowed_types = (isset($options['allowed_types_comuser'])) ? $options['allowed_types_comuser'] : 'gif|jpg|jpeg|png';

$allowed_ext = explode('|', $allowed_types);

if (!in_array($ext, $allowed_ext)) die('not allowed');

// Закончили проверки.

// mso_flush_cache_mask('get_userfiles');
   mso_flush_cache();

// Полный путь к каталогу пользователя
$subdir = (isset($options['user_subdir'])) ? $options['user_subdir'] : 'userfile';
$subdir = getinfo('uploads_dir') . '/' . $subdir;
$up_dir = $subdir . '/' . $comusers_id . '/';

	$fn = _slug($fn);
	
	$ext = strtolower(substr(strrchr($fn, '.'), 1));
	$name = substr($fn, 0, strlen($fn) - strlen($ext) - 1);

	// Если имя файла пустое, только расширение.
	if ($fn == '.' . $ext) $fn = '1' . $fn;

	// значение checked передается как строка
	$replace_file = isset($_SERVER['HTTP_X_REQUESTED_REPLACEFILE']) ? $_SERVER['HTTP_X_REQUESTED_REPLACEFILE'] : 'false';	
	
	// получаем количество неподтвержденных файлов пользователя $comusers_id
	$uploader_count = mso_get_option('comuser_uploader_count', 'plugins', array() );	
	if (!isset($uploader_count[$comusers_id])) $uploader_count[$comusers_id] = 0;
	
	// сколько разрешено загрузок
    if (!isset($options['max_count'])) $options['max_count'] ='10';		
	$max_count=(int)$options['max_count'];
	
	if ($uploader_count[$comusers_id]>=$max_count) // если превысили
	{	
	    // если файл не существует или нельзя заменять файл - запрещаем действие
	    if (strtolower($replace_file) == 'false' or !file_exists($up_dir . $fn))
		{
			$log = date("m.d.y H:i:s", time()) . '   comuser_id: ' . $comusers_id . ' Превышено ' . $fn . '<br>';
			file_put_contents(getinfo('plugins_dir') .'comuser_uploader/log.txt' , $log, FILE_APPEND); 
			email_message_new_upload($comusers_id, $fn , false);
			die('files moderated');
		}	
    }
	else // добавляем один
	{
		$uploader_count[$comusers_id]++;
		mso_add_option('comuser_uploader_count', $uploader_count, 'plugins');
	}
	
	email_message_new_upload($comusers_id, $fn , true);
	
	// качество картинок задаётся через опцию
	$quality = mso_get_option('upload_resize_images_quality', 'general', 90);

	
    $log = date("m.d.y H:i:s", time()) . '   comuser_id: ' . $comusers_id . '   ' . $fn . '<br>';
	file_put_contents(getinfo('plugins_dir') .'comuser_uploader/log.txt' , $log, FILE_APPEND);
	
	
	// Если файл уже существует и нельзя заменять ищем новое имя
	if (strtolower($replace_file) == 'false' and file_exists($up_dir . $fn))
	{
		for ($i = 1; $i < 100; $i++)
		{
			$fn = $name . '-' . $i . '.' . $ext;
			if (!file_exists($up_dir . $fn)) break;
		}
	}
	

	
	
	file_put_contents( $up_dir . $fn, file_get_contents('php://input') );

	if (!in_array($ext, array('jpg', 'jpeg', 'png', 'gif')))
	{
		// Не картинка, загрузили, больше ничего не надо.
		echo ' DONE! <b>' . $fn . '</b>';
		return;
	}
	
	$resize_images = (isset($options['resize_images']) ? $options['resize_images'] : '600');
	
	$resize_images_type = (isset($options['resize_images_type'])) ? $options['resize_images_type'] : 'width';
	
	$size_image_mini_w = (isset($options['size_image_mini_w'])) ? $options['size_image_mini_w'] : '200';
	
	$size_image_mini_h = (isset($options['size_image_mini_h'])) ? $options['size_image_mini_h'] : '150';
	
	$image_mini_type = (isset($options['resize_mini_type'])) ? $options['resize_mini_type'] : 'width';
	
	// ватермарка
	if (file_exists(getinfo('uploads_dir') . 'watermark.png'))
	{
		$use_watermark = (isset($options['use_watermark'])) ? $options['use_watermark'] : 0; 
		$use_watermark_mini = (isset($options['use_watermark_mini'])) ? $options['use_watermark_mini'] : 0; 
	}
	else
	{
		$use_watermark = false; $use_watermark_mini = false;
	}
	
	if (!function_exists('thumb_generate')) require(getinfo('shared_dir') . 'stock/thumb/thumb.php');

	// У нас есть uploads_dir, а нужен url
	$url = str_replace(getinfo('uploads_dir'), getinfo('uploads_url'), $up_dir);
    $image_mini_url = $url . $fn;
	// читаем exif на предмет ориентации
	$rotation = mso_exif_rotate($up_dir . $fn);
	
	// если нужно повернуть
	// если большая картинка то это может грузить сервер, зато сразу нужная ориентация
	if ($rotation)
	{
		echo ' ROTATE... ';
		thumb_rotate($up_dir . $fn, $rotation, $quality);
	}
	
	// текущие размеры
	$size = $new_size = getimagesize($up_dir . $fn);
	$width = $new_width = $size[0];
	$height = $new_height = $size[1];
	
	if ($resize_images_type == 'width')
	{
		if ($width > $resize_images) 
		{
			echo ' RESIZE (width) ... ';
			$new_width = $resize_images;
			$new_height = round($height / ($width/$new_width));
			thumb_generate($url . $fn, $new_width, $new_height, false, 'resize', true, '', false, $quality);
		}
	}
	elseif ($resize_images_type == 'height')
	{
		if ($height > $resize_images) 
		{
			echo ' RESIZE (height) ... ';
			$new_height = $resize_images;
			$new_width = round($width / ($height/$new_height));
			thumb_generate($url . $fn, $new_width, $new_height, false, 'resize', true, '', false, $quality);
		}
	}
	elseif ($resize_images_type == 'max') // автоматом вычисляем максимальную сторону
	{
		if ($width > $resize_images or $height > $resize_images)
		{
			echo ' RESIZE (max) ... ';
			
			if ($width > $height)
			{
				$new_width = $resize_images;
				$new_height = round($height / ($width/$new_width));
			}
			else
			{
				$new_height = $resize_images;
				$new_width = round($width / ($height/$new_height));
			}
			
			thumb_generate($url . $fn, $new_width, $new_height, false, 'resize', true, '', false, $quality);
		}
	}
	elseif ($resize_images_type == 'crop_center_ratio_auto') // кроп по центру с автовысотой
	{
		if ($width > $resize_images)
		{
			echo ' RESIZE (crop auto-height) ... ';
			$new_width = $resize_images;
			thumb_generate($url . $fn, $new_width, 0, false, 'crop_center_ratio_auto', true, '', false, $quality);
		}
	}
	elseif ($resize_images_type == 'crop_center_ratio_4_3') // кроп по центру в пропорции 4:3
	{
		if ($width > $resize_images)
		{
			echo ' RESIZE (crop 4:3) ... ';
			$new_width = $resize_images;
			thumb_generate($url . $fn, $new_width, '4-3', false, 'crop_center_ratio_4_3', true, '', false, $quality);
		}
	}
	elseif ($resize_images_type == 'crop_center_ratio_3_2') // кроп по центру в пропорции 3:2
	{
		if ($width > $resize_images)
		{
			echo ' RESIZE (crop 3:2) ... ';
			$new_width = $resize_images;
			thumb_generate($url . $fn, $new_width, '3-2', false, 'crop_center_ratio_3_2', true, '', false, $quality);
		}
	}
	elseif ($resize_images_type == 'crop_center_ratio_16_9') // кроп по центру в пропорции 16:9
	{
		if ($width > $resize_images)
		{
			echo ' RESIZE (crop 16:9) ... ';
			$new_width = $resize_images;
			thumb_generate($url . $fn, $new_width, '16-9', false, 'crop_center_ratio_16_9', true, '', false, $quality);
		}
	}

	
	// миниатюру делаем стандартно
	if ($image_mini_type != 'none') // если не делать миниатюру
	{
		echo ' MINI... ';

		if ($image_mini_type == 'width')
		{
			if ($width > $size_image_mini_w) 
			{
				echo ' RESIZE (width) ... ';
				$new_width = $size_image_mini_w;
				$new_height = round($height / ($width/$new_width));
				$image_mini_url = thumb_generate($url . $fn, $new_width, $new_height, false, 'resize', true, 'mini', false, $quality);
				$new_width = $size_image_mini_w;
				$new_height = round($height / ($width/$new_width));
				$image_mini_url = thumb_generate($url . $fn, $new_width, $new_height, false, 'resize', true, 'mini', false, $quality);				
			}
		}
		elseif ($image_mini_type == 'height')
		{
			if ($height > $resize_images) 
			{
				echo ' RESIZE (height) ... ';
				$new_height = $size_image_mini_h;
				$new_width = round($width / ($height/$new_height));
				$image_mini_url = thumb_generate($url . $fn, $new_width, $new_height, false, 'resize', true, 'mini', false, $quality);
			}
		}
		elseif ($image_mini_type == 'max') // автоматом вычисляем максимальную сторону
		{
			if ($width > $size_image_mini_w or $height > $size_image_mini_h)
			{
				echo ' RESIZE (max) ... ';
				if ($width > $height)
				{
					$new_width = $resize_images;
					$new_height = round($height / ($width/$new_width));
				}
				else
				{
					$new_height = $resize_images;
					$new_width = round($width / ($height/$new_height));
				}
				$image_mini_url = thumb_generate($url . $fn, $new_width, $new_height, false, 'resize', true, 'mini', false, $quality);
			}
		}
		elseif ($image_mini_type == 'crop_center_ratio_auto') // кроп по центру с автовысотой
		{
			if ($width > $size_image_mini_w)
			{
				echo ' RESIZE (crop auto-height) ... ';
				$new_width = $resize_images;
				$image_mini_url = thumb_generate($url . $fn, $new_width, 0, false, 'crop_center_ratio_auto', true, 'mini', false, $quality);
			}
		}
		elseif ($image_mini_type == 'crop_center_ratio_4_3') // кроп по центру в пропорции 4:3
		{
			if ($width > $size_image_mini_w)
			{
				echo ' RESIZE (crop 4:3) ... ';
				$new_width = $resize_images;
				$image_mini_url = thumb_generate($url . $fn, $new_width, '4-3', false, 'crop_center_ratio_4_3', true, 'mini', false, $quality);
			}
		}
		elseif ($image_mini_type == 'crop_center_ratio_3_2') // кроп по центру в пропорции 3:2
		{
			if ($width > $size_image_mini_w)
			{
				echo ' RESIZE (crop 3:2) ... ';
				$new_width = $resize_images;
				$image_mini_url = thumb_generate($url . $fn, $new_width, '3-2', false, 'crop_center_ratio_3_2', true, 'mini', false, $quality);
			}
		}
		elseif ($image_mini_type == 'crop_center_ratio_16_9') // кроп по центру в пропорции 16:9
		{
			if ($width > $size_image_mini_w)
			{
				echo ' RESIZE (crop 16:9) ... ';
				$new_width = $resize_images;
				$image_mini_url = thumb_generate($url . $fn, $new_width, '16-9', false, 'crop_center_ratio_16_9', true, 'mini', false, $quality);
			}
		}
		
	//	$image_mini_url = thumb_generate($url . $fn, $size_image_mini_w, $size_image_mini_h, false, $image_mini_type, true, 'mini', false, $quality);
		
		
		// если у миниатюры нужно поставить водяной знак
		if ($use_watermark_mini)
		{
			echo ' WATERMARK MINI... ';
			
			$watermark_type = mso_get_option('watermark_type',  'general', '1');
			
			$image_mini_fn = str_replace(getinfo('uploads_url'), getinfo('uploads_dir'), $image_mini_url);
			
			if (file_exists($image_mini_fn))
				thumb_watermark($image_mini_fn, getinfo('uploads_dir') . 'watermark.png', $watermark_type);
		}
	}
	
	// водяной знак на основное изображение
	if ($use_watermark)
	{
		echo ' WATERMARK... ';
		$watermark_type = mso_get_option('watermark_type',  'general', '1');
		
		thumb_watermark($up_dir . $fn, getinfo('uploads_dir') . 'watermark.png', $watermark_type);
	}
	
	echo ' THUMB... ';
	//100x100 — превью в _mso_i с тем же типом кропа
	$type_resize=array('height', 'width', 'max');
	if (in_array($image_mini_type, $type_resize)) $image_thumb_type = 'resize';
	else $image_thumb_type = $image_mini_type;
	thumb_generate($url . $fn, 100, 100, false, $image_thumb_type, true, '_mso_i', false, $quality);
	
	
	
	echo ' DONE! <b>' . $fn . '</b> Available: ' . ($max_count-$uploader_count[$comusers_id]);
	
/*}*/

function _slug($slug)
{
	$repl = array(
	"А"=>"a", "Б"=>"b",  "В"=>"v",  "Г"=>"g",   "Д"=>"d",
	"Е"=>"e", "Ё"=>"jo", "Ж"=>"zh",
	"З"=>"z", "И"=>"i",  "Й"=>"j",  "К"=>"k",   "Л"=>"l",
	"М"=>"m", "Н"=>"n",  "О"=>"o",  "П"=>"p",   "Р"=>"r",
	"С"=>"s", "Т"=>"t",  "У"=>"u",  "Ф"=>"f",   "Х"=>"h",
	"Ц"=>"c", "Ч"=>"ch", "Ш"=>"sh", "Щ"=>"shh", "Ъ"=>"",
	"Ы"=>"y", "Ь"=>"",   "Э"=>"e",  "Ю"=>"ju", "Я"=>"ja",

	"а"=>"a", "б"=>"b",  "в"=>"v",  "г"=>"g",   "д"=>"d",
	"е"=>"e", "ё"=>"jo", "ж"=>"zh",
	"з"=>"z", "и"=>"i",  "й"=>"j",  "к"=>"k",   "л"=>"l",
	"м"=>"m", "н"=>"n",  "о"=>"o",  "п"=>"p",   "р"=>"r",
	"с"=>"s", "т"=>"t",  "у"=>"u",  "ф"=>"f",   "х"=>"h",
	"ц"=>"c", "ч"=>"ch", "ш"=>"sh", "щ"=>"shh", "ъ"=>"",
	"ы"=>"y", "ь"=>"",   "э"=>"e",  "ю"=>"ju",  "я"=>"ja",

	# украина
	"Є" => "ye", "є" => "ye", "І" => "i", "і" => "i",
	"Ї" => "yi", "ї" => "yi", "Ґ" => "g", "ґ" => "g",
	
	# беларусь
	"Ў"=>"u", "ў"=>"u", "'"=>"",
	
	# румынский
	"ă"=>'a', "î"=>'i', "ş"=>'sh', "ţ"=>'ts', "â"=>'a',
	
	"«"=>"", "»"=>"", "—"=>"-", "`"=>"", " "=>"-",
	"["=>"", "]"=>"", "{"=>"", "}"=>"", "<"=>"", ">"=>"",

	"?"=>"", ","=>"", "*"=>"", "%"=>"", "$"=>"",

	"@"=>"", "!"=>"", ";"=>"", ":"=>"", "^"=>"", "\""=>"",
	"&"=>"", "="=>"", "№"=>"", "\\"=>"", "/"=>"", "#"=>"",
	"("=>"", ")"=>"", "~"=>"", "|"=>"", "+"=>"", "”"=>"", "“"=>"",
	"'"=>"",

	"’"=>"",
	"—"=>"-", // mdash (длинное тире)
	"–"=>"-", // ndash (короткое тире)
	"™"=>"tm", // tm (торговая марка)
	"©"=>"c", // (c) (копирайт)
	"®"=>"r", // (R) (зарегистрированная марка)
	"…"=>"", // (многоточие)
	"“"=>"",
	"”"=>"",
	"„"=>"",
	
	" "=>"-",
	);
		
	$slug = strtr(trim($slug), $repl);
	$slug = htmlentities($slug); // если есть что-то из юникода
	$slug = strtr(trim($slug), $repl);
	$slug = strtolower($slug);
	
	return $slug;
}

return;


// функция отправляет админу уведомление о новой загрузке
function email_message_new_upload($comuser_id = 0, $fn = '', $result=true, $data = [])
{
    // хук 
    // mso_hook('mso_email_message_new_comment', $data);


    $email = mso_get_option('comments_email', 'general', false); // email куда приходят уведомления

    // если не задан, отдельный email, то берём email администратора.
    if (!$email) $email = mso_get_option('admin_email', 'general', false);

    if (!$email) return false;

    $CI = &get_instance();

    if ($result) $subject = '[' . getinfo('name_site') . '] ' . '(+) ' . tf('Загружен файл') . ' (' . $comuser_id . '/' . $fn . ')';
	else $subject = '[' . getinfo('name_site') . '] ' . '(-) ' . tf('НЕ загружен файл') . ' (' . $comuser_id . '/' . $fn . ')';
    
	$referer = mso_clean_str($_SERVER['HTTP_REFERER'], 'xss');

    $CI->db->select('comusers_nik, comusers_email');
    $CI->db->from('comusers');
    $CI->db->where('comusers_id', $comuser_id);

    $query = $CI->db->get();

    if ($query->num_rows() > 0) {
        $comusers = $query->row();
        $comuser_nik = $comusers->comusers_nik;
        $comuser_email = $comusers->comusers_email;
        $comuser_url = getinfo('siteurl') . 'users/' . $comuser_id;
    }

    // уведомление
	
	if ($result) $text = 'Загружен файл.';
	else $text = 'НЕ загружен файл.';
		
    $text .= '
	' . $fn . '
referer ' .	$referer . '
Номер ' . $comuser_id . '
Имя ' . $comuser_nik . '
Почта ' . $comuser_email . '
Ссылка ' . $comuser_url;
	
    return mso_mail($email, $subject, $text);
}

# end of file